import Globals
from Globals import HTMLFile
from AccessControl.User import BasicUserFolder
from OFS.ObjectManager import ObjectManager
from OFS.PropertyManager import PropertyManager
from OFS.SimpleItem import Item
from AccessControl.Role import RoleManager

manage_addUserInfoFolderForm=HTMLFile('uifAdd',globals())

def manage_addUserInfoFolder(self,id,productName,className,REQUEST=None,**ignored):
    """ Add a new User Info Folder"""
    productName=str(productName)
    className=str(className)
    self=self.this()
    obj=UserInfoFolder(id,productName,className)
    self._setObject(id,obj)
    if REQUEST is not None:
        REQUEST['RESPONSE'].redirect(self.absolute_url()+'/manage_main')
    
class UserInfoFolder(ObjectManager,PropertyManager,Item,RoleManager):
    """A UserInfoFolder object is an ObjectManager synchronized with a UserFolder."""

    meta_type='User Info Folder'

    manage_options=(
        ObjectManager.manage_options
        +PropertyManager.manage_options
        +Item.manage_options
        +RoleManager.manage_options
        )

    __ac_permissions__=(
        ('Delete objects',
         ('cleanup',)),
        )

    _properties=({'id':'productName', 'type': 'string'},
                 {'id':'className', 'type':'string'},
                 )

    
    def __init__(self, id, productName, className):
        self.__name__=id
        self.productName=productName
        self.className=className

    def cleanup(self,REQUEST=None):
        """ Removes object associated with deleted users"""
        userList=self.this().acl_users.getUserNames()
        currentIds=ObjectManager.objectIds(self)
        for obj in currentIds:
            if not obj in userList:
                self._delObject(obj)
        if REQUEST is not None:
            REQUEST['RESPONSE'].redirect(self.absolute_url()+'/manage_main')
            
    def objectIds(self, spec=None):
        """Returns a list of user ids"""
        self=self.this()
        userList=self.acl_users.getUserNames()
        return userList

    def _getOb(self, id, default=''):
        if not hasattr(self, id):
            product=self.manage_addProduct[self.productName]
            zclass=eval('product.'+self.className)
            obj=apply(zclass,[])
            obj._setId(id)
            self._setObject(id,obj,set_owner=0)
            return obj
        return getattr(self, id)


    def all_meta_types(self):
        return ()

Globals.default__class_init__(UserInfoFolder)
